#Compile Exe
#Include "WIN32API.INC"

'--------------------------------------------------------------------
%IDC_LABEL1 = 200


Function PBMain () As Long
   Local hDlg As Dword

  Dialog New 0, "Dialog's Scroll Bars ",,, 450, 250, _
  %WS_POPUP Or %WS_BORDER _
        Or %WS_DLGFRAME Or %WS_THICKFRAME Or %WS_CAPTION Or %WS_SYSMENU Or _
        %WS_MINIMIZEBOX Or %WS_MAXIMIZEBOX Or %WS_CLIPSIBLINGS Or _
        %WS_HSCROLL Or %WS_VSCROLL Or %WS_VISIBLE Or %DS_MODALFRAME Or _
        %DS_3DLOOK Or %DS_NOFAILCREATE Or %DS_SETFONT, %WS_EX_CONTROLPARENT _
        Or %WS_EX_LEFT Or %WS_EX_LTRREADING Or %WS_EX_RIGHTSCROLLBAR,  To hDlg
  Dialog Set Color hDlg, -1, RGB(74, 164, 74)
  '------------------------------------------------------------------
  Control Add Label, hDlg, %IDC_LABEL1, "Keep scrolling !", 100, 100, 300, 200
  Control Set Color hDlg, %IDC_LABEL1, -1, RGB(74, 255, 74)

  '------------------------------------------------------------------
  Dialog Show Modal hDlg Call DlgProc

End Function


CallBack Function DlgProc() As Long


  ' initialize scrollbar constants here
  Local w As Long, h As Long, oldPos As Long, si As SCROLLINFO
  Local vt As Long, ht As Long, hs As Long, vs As Long

'==========================================================================
'HERE YOU WILL SETUP VALUES FOR THE CONSTANTS CONTROLING BEHAVIOUR OF THE
'SCROLL BARS:   (try to experiment with these values)
'==========================================================================

    w = 600    'This is the number of dialog units by which the Dialog's Window
               'will scroll horizontaly if the thumb of the Scrolling Bar
               'travels between its extreme positions left and right
               'Reasonable (but not compulsory) value for it is between 200 to 2000

    h = 400    'This is the number of dialog units by which the Dialog's Window
               'will scroll verticaly if the thumb of the Scrolling Bar
               'travels between its extreme positions top and bottom
               'Reasonable (but not compulsory) value for it is between 200 to 1600

    vt = 50    'lenght of the vertical scroll bar's thumb, this is also the amount
               'of dialog units by which the dialog will scroll verticaly if mouse is
               'clicked between the ends of the scroll bar and the thumb itself
               'reasonable value for it is between 10 and h/2

    ht = 50    'lenght of the horizontal scroling bar's thumb, this is also the amount
               'of dialog units by which the dialog will scroll horizontaly if mouse is
               'clicked between the ends of the scroll bar and the thumb itself
               'reasonable value for it is between 10 and w/2

    hs = 5     'number of dialog units by which the Dialog scrolls horizontaly when the
               'small arrow on either end of scroling bar is activated by mouse
               'reasonable values for it is between 1 and 30. Small value produces
               'smother but slower scrolling, the higher value is faster but more
               'jerki - the Dialog scrolls by steps determined by this value.

    vs = 5     'number of dialog units by which the Dialog scrolls verticaly when the
               'small arrow on either end of scroling bar is activated by mouse
               'reasonable values for it is between 1 and 30. Small value produces
               'smother but slower scrolling, the higher value is faster but more
               'jerki - the Dialog scrolls by steps determined by this value.

'----------------
   'If scroling by dialog units and not by pixels is giving you stomachache
   'remove REM from the next line.

   Rem DIALOG UNITS CBHNDL, w, h TO PIXELS w, h

'==========================================================================
' This is all you have to decide upon, the rest just copy.
' If you remove all comments, the code become quite lean!
'==========================================================================

  Select Case CbMsg
     Case %WM_INITDIALOG

       ' initialize scrollbars here
       '---------------------------------------------------------------------------------
        si.cbSize = Len(si)                   ' get place holders for the si parameters
        si.fMask  = %SIF_ALL                  ' setting the topological space for the scroll bars
        si.nMin   = 0                         ' min scroll pos
        si.nMax   = h                         ' max scroll pos
        si.nPage  = vt                        ' lenght of the vertical scroll bar's thumb
        SetScrollInfo CbHndl, %SB_VERT, si, 1 ' initial setup of the vertical scrollbar, "1" represents
                                              ' "TRUE" and causes redraw of the scroll bar
        '--------------------------------------------------------------------------------
        si.nMin   = 0                         ' min scroll pos
        si.nMax   = w                         ' max scroll pos
        si.nPage  = ht                        ' width of the horizontal scroll bar thumb
        si.nPos   = 0                         ' initial position of the thumbs
        SetScrollInfo CbHndl, %SB_HORZ, si, 1 ' initial setup of the horizontal scrollbar, "1" represents
                                              ' "TRUE" and causes redraw of the scroll bar
        '--------------------------------------------------------------------------------


     Case %WM_COMMAND      ' <- a control is calling
        Select Case CbCtl  ' <- look at control's id
           Case %IDCANCEL
              If CbCtlMsg = %BN_CLICKED Or CbCtlMsg = 1 Then 'end prog
                 Dialog End CbHndl
              End If

        End Select


     Case %WM_HSCROLL  ' call from the horizontal scroll bar
        si.cbSize = SizeOf(si)
        si.fMask  = %SIF_ALL
        GetScrollInfo CbHndl, %SB_HORZ, si
        oldPos = si.nPos

        Select Case LoWrd(CbWParam)
            Case %SB_LINELEFT   : si.nPos = si.nPos - hs
            Case %SB_PAGELEFT   : si.nPos = si.nPos - si.nPage
            Case %SB_LINERIGHT  : si.nPos = si.nPos + hs
            Case %SB_PAGERIGHT  : si.nPos = si.nPos + si.nPage
            Case %SB_THUMBTRACK : si.nPos = HiWrd(CbWParam)
            Case Else           : Exit Function
        End Select

        'To limit scroling range remove REM from the next line.
        'If you don't then you can keep scrolling indefinitelly (well, almost)
        'by using small arrrows on the end of the scroll bar.

    Rem    si.nPos = MAX&(si.nMin, MIN&(si.nPos, si.nMax - si.nPage))

        ' Update the scroll bar and scroll the client area
        si.fMask  = %SIF_POS
        SetScrollInfo CbHndl, %SB_HORZ, si, 1     'remember new geometry of the horizontal scroll bar
        ScrollWindow CbHndl, oldPos - si.nPos, 0, ByVal %NULL, ByVal %NULL   'actual scroling action
        Function = 1


     Case %WM_VSCROLL  'call from the vertical scroll bar
        si.cbSize = SizeOf(si)
        si.fMask  = %SIF_ALL
        GetScrollInfo CbHndl, %SB_VERT, si
        oldPos = si.nPos

        Select Case LoWrd(CbWParam)
            Case %SB_LINEUP     : si.nPos = si.nPos - vs
            Case %SB_PAGEUP     : si.nPos = si.nPos - si.nPage
            Case %SB_LINEDOWN   : si.nPos = si.nPos + vs
            Case %SB_PAGEDOWN   : si.nPos = si.nPos + si.nPage
            Case %SB_THUMBTRACK : si.nPos = HiWrd(CbWParam)
            Case Else           : Exit Function
        End Select

        'To limit scroling range remove REM from the next line
        'If you don't then you can keep scrolling indefinitelly (well, almost)
        'by using small arrrows on the end of the scroll bar.

    Rem    si.nPos = MAX&(si.nMin, MIN&(si.nPos, si.nMax - si.nPage + 1))

        ' Update the scroll bar and scroll the client area
        si.fMask = %SIF_POS
        SetScrollInfo CbHndl, %SB_VERT, si, 1    'remember new geometry of the vertical scroll bar
        ScrollWindow CbHndl, 0, oldPos - si.nPos, ByVal %NULL, ByVal %NULL  'actual scroling action
        Function = 1

  End Select
End Function
